/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFNumber;

import dstep.corefoundation.CFBase;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFBoolean;
alias __CFBoolean* CFBooleanRef;
alias int CFNumberType;
struct __CFNumber;
alias __CFNumber* CFNumberRef;

extern (C)
{
	extern
	{
		const CFBooleanRef kCFBooleanTrue;
		const CFBooleanRef kCFBooleanFalse;
		const CFNumberRef kCFNumberPositiveInfinity;
		const CFNumberRef kCFNumberNegativeInfinity;
		const CFNumberRef kCFNumberNaN;
	}
}

enum
{
	kCFNumberSInt8Type = 1,
	kCFNumberSInt16Type = 2,
	kCFNumberSInt32Type = 3,
	kCFNumberSInt64Type = 4,
	kCFNumberFloat32Type = 5,
	kCFNumberFloat64Type = 6,
	kCFNumberCharType = 7,
	kCFNumberShortType = 8,
	kCFNumberIntType = 9,
	kCFNumberLongType = 10,
	kCFNumberLongLongType = 11,
	kCFNumberFloatType = 12,
	kCFNumberDoubleType = 13,
	kCFNumberCFIndexType = 14,
	kCFNumberNSIntegerType = 15,
	kCFNumberCGFloatType = 16,
	kCFNumberMaxType = 16
}

extern (C)
{
	uint CFBooleanGetTypeID ();
	ubyte CFBooleanGetValue (CFBooleanRef boolean);
	uint CFNumberGetTypeID ();
	CFNumberRef CFNumberCreate (CFAllocatorRef allocator, int theType, void* valuePtr);
	int CFNumberGetType (CFNumberRef number);
	int CFNumberGetByteSize (CFNumberRef number);
	ubyte CFNumberIsFloatType (CFNumberRef number);
	ubyte CFNumberGetValue (CFNumberRef number, int theType, void* valuePtr);
	int CFNumberCompare (CFNumberRef number, CFNumberRef otherNumber, void* context);
}