/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSKeyValueCoding;

import dstep.foundation.NSArray;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSError;
import dstep.foundation.NSSet;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

import bindings = dstep.foundation.NSKeyValueCoding_bindings;

const NSString NSUndefinedKeyException;
const NSString NSAverageKeyValueOperator;
const NSString NSCountKeyValueOperator;
const NSString NSDistinctUnionOfArraysKeyValueOperator;
const NSString NSDistinctUnionOfObjectsKeyValueOperator;
const NSString NSDistinctUnionOfSetsKeyValueOperator;
const NSString NSMaximumKeyValueOperator;
const NSString NSMinimumKeyValueOperator;
const NSString NSSumKeyValueOperator;
const NSString NSUnionOfArraysKeyValueOperator;
const NSString NSUnionOfObjectsKeyValueOperator;
const NSString NSUnionOfSetsKeyValueOperator;

static this ()
{
	NSUndefinedKeyException = new NSString(bindings.NSUndefinedKeyException);
	NSAverageKeyValueOperator = new NSString(bindings.NSAverageKeyValueOperator);
	NSCountKeyValueOperator = new NSString(bindings.NSCountKeyValueOperator);
	NSDistinctUnionOfArraysKeyValueOperator = new NSString(bindings.NSDistinctUnionOfArraysKeyValueOperator);
	NSDistinctUnionOfObjectsKeyValueOperator = new NSString(bindings.NSDistinctUnionOfObjectsKeyValueOperator);
	NSDistinctUnionOfSetsKeyValueOperator = new NSString(bindings.NSDistinctUnionOfSetsKeyValueOperator);
	NSMaximumKeyValueOperator = new NSString(bindings.NSMaximumKeyValueOperator);
	NSMinimumKeyValueOperator = new NSString(bindings.NSMinimumKeyValueOperator);
	NSSumKeyValueOperator = new NSString(bindings.NSSumKeyValueOperator);
	NSUnionOfArraysKeyValueOperator = new NSString(bindings.NSUnionOfArraysKeyValueOperator);
	NSUnionOfObjectsKeyValueOperator = new NSString(bindings.NSUnionOfObjectsKeyValueOperator);
	NSUnionOfSetsKeyValueOperator = new NSString(bindings.NSUnionOfSetsKeyValueOperator);
}

template TNSDeprecatedKeyValueCoding ()
{
	static bool useStoredAccessor ();
	Object storedValueForKey (NSString key);
	void takeStoredValue (Object value, NSString key);
	void takeValue (Object value, NSString key);
	void takeValue (Object value, NSString keyPath);
	Object handleQueryWithUnboundKey (NSString key);
	void handleTakeValue (Object value, NSString key);
	void unableToSetNilForKey (NSString key);
	NSDictionary valuesForKeys (NSArray keys);
	void takeValuesFromDictionary (NSDictionary properties);
}

template TNSKeyValueCoding ()
{
	static bool accessInstanceVariablesDirectly ();
	Object valueForKey (NSString key);
	void setValue (Object value, NSString key);
	bool validateValue (id* ioValue, NSString inKey, NSError** outError);
	NSMutableArray mutableArrayValueForKey (NSString key);
	NSMutableSet mutableSetValueForKey (NSString key);
	Object valueForKeyPath (NSString keyPath);
	void setValue (Object value, NSString keyPath);
	bool validateValue (id* ioValue, NSString inKeyPath, NSError** outError);
	NSMutableArray mutableArrayValueForKeyPath (NSString keyPath);
	NSMutableSet mutableSetValueForKeyPath (NSString keyPath);
	Object valueForUndefinedKey (NSString key);
	void setValue (Object value, NSString key);
	void setNilValueForKey (NSString key);
	NSDictionary dictionaryWithValuesForKeys (NSArray keys);
	void setValuesForKeysWithDictionary (NSDictionary keyedValues);
}

