/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSScriptExecutionContext;

import dstep.foundation.NSConnection;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSScriptExecutionContext : NSObject
{
	mixin ObjcWrap;

	static NSScriptExecutionContext sharedScriptExecutionContext ()
	{
		return invokeObjcSelfClass!(NSScriptExecutionContext, "sharedScriptExecutionContext");
	}

	Object topLevelObject ()
	{
		return invokeObjcSelf!(Object, "topLevelObject");
	}

	void setTopLevelObject (Object obj)
	{
		return invokeObjcSelf!(void, "setTopLevelObject:", Object)(obj);
	}

	Object objectBeingTested ()
	{
		return invokeObjcSelf!(Object, "objectBeingTested");
	}

	void setObjectBeingTested (Object obj)
	{
		return invokeObjcSelf!(void, "setObjectBeingTested:", Object)(obj);
	}

	Object rangeContainerObject ()
	{
		return invokeObjcSelf!(Object, "rangeContainerObject");
	}

	void setRangeContainerObject (Object obj)
	{
		return invokeObjcSelf!(void, "setRangeContainerObject:", Object)(obj);
	}
}

