/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSScriptKeyValueCoding;

import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

import bindings = dstep.foundation.NSScriptKeyValueCoding_bindings;

NSString NSOperationNotSupportedForKeyException;

static this ()
{
	NSOperationNotSupportedForKeyException = new NSString(bindings.NSOperationNotSupportedForKeyException);
}

template TNSScriptKeyValueCoding ()
{
	Object valueAtIndex (NSUInteger index, NSString key);
	Object valueWithName (NSString name, NSString key);
	Object valueWithUniqueID (Object uniqueID, NSString key);
	void insertValue (Object value, NSUInteger index, NSString key);
	void removeValueAtIndex (NSUInteger index, NSString key);
	void replaceValueAtIndex (NSUInteger index, NSString key, Object value);
	void insertValue (Object value, NSString key);
	Object coerceValue (Object value, NSString key);
}

