/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSSortDescriptor;

import dstep.foundation.NSArray;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSSortDescriptor : NSObject, INSCoding, INSCopying
{
	mixin ObjcWrap;

	Object initWithKey (NSString key, bool ascending)
	{
		return invokeObjcSelf!(Object, "initWithKey:ascending:", NSString, bool)(key, ascending);
	}

	this (NSString key, bool ascending)
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id result = Bridge.invokeObjcMethod!(id, "initWithKey:ascending:", NSString, bool)(objcObject, key, ascending);

		if (result)
			objcObject = ret;

		dObject = this;
	}

	Object initWithKey (NSString key, bool ascending, SEL selector)
	{
		return invokeObjcSelf!(Object, "initWithKey:ascending:selector:", NSString, bool, SEL)(key, ascending, selector);
	}

	this (NSString key, bool ascending, SEL selector)
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id result = Bridge.invokeObjcMethod!(id, "initWithKey:ascending:selector:", NSString, bool, SEL)(objcObject, key, ascending, selector);

		if (result)
			objcObject = ret;

		dObject = this;
	}

	NSString key ()
	{
		return invokeObjcSelf!(NSString, "key");
	}

	bool ascending ()
	{
		return invokeObjcSelf!(bool, "ascending");
	}

	SEL selector ()
	{
		return invokeObjcSelf!(SEL, "selector");
	}

	int compareObject (Object object1, Object object2)
	{
		return invokeObjcSelf!(int, "compareObject:toObject:", Object, Object)(object1, object2);
	}

	Object reversedSortDescriptor ()
	{
		return invokeObjcSelf!(Object, "reversedSortDescriptor");
	}

	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}

	Object initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(Object, "initWithCoder:", NSCoder)(aDecoder);
	}

	this (NSCoder aDecoder)
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id result = Bridge.invokeObjcMethod!(id, "initWithCoder:", NSCoder)(objcObject, aDecoder);

		if (result)
			objcObject = ret;

		dObject = this;
	}

	Object copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(Object, "copyWithZone:", NSZone*)(zone);
	}
}

template TNSSortDescriptorSorting ()
{
	NSArray sortedArrayUsingDescriptors (NSArray sortDescriptors)
	{
		return invokeObjcSelf!(NSArray, "sortedArrayUsingDescriptors:", NSArray)(sortDescriptors);
	}
}

