/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Feb 1, 2009
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.objc.bridge.Wrapper;

import dstep.internal.String;
import dstep.objc.bridge.Bridge;
import dstep.objc.bridge.Capsule;
import dstep.objc.message;
import dstep.objc.objc;
import dstep.objc.runtime;

class ObjcWrapper
{	
	static private Class objcClass_;
	static private Class objcSuperClass_;
	
	private id objcObject_;
	private objc_super* objcSuper_;
	
	this ()
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id ret = Bridge.invokeObjcMethod!(id, "init")(objcObject);
		
		if (ret)
			objcObject = ret;
		
		dObject = this;
	}
		
	/// Initialize object from an Objective-C object instance to wrap.
	this (id object)
	{
		objcObject_ = object;
		dObject = this;
	}
	
	static Class objcClass ()
	{
		return capsuleClass;
	}
	
	static Class objcSuperClass ()
	{
		if (!objcSuperClass_)
			return objcSuperClass_ = objcClass.getSuperclass;
		
		return objcSuperClass_;
	}
	
	id objcObject ()
	{
		return objcObject_;
	}
	
	protected id objcObject (id object)
	{
		return objcObject_ = object;
	}
	
	protected void dObject (Object dObject)
	{
		Bridge.setDObject(dObject, objcObject);
	}
	
	objc_super* objcSuper ()
	{
		if (!objcSuper_)
		{
			objcSuper_ = new objc_super;
			objcSuper_.receiver = objcObject;
			objcSuper_.cls = objcSuperClass;
		}
		
		return objcSuper_;
	}
}