/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.AuthSession;

import dstep.security.Authorization;

alias uint SecuritySessionId;
alias uint SessionAttributeBits;
alias uint SessionCreationFlags;

enum
{
	noSecuritySession = 0,
	callerSecuritySession = (cast(SecuritySessionId)-1)
}

enum
{
	sessionIsRoot = 0x0001,
	sessionHasGraphicAccess = 0x0010,
	sessionHasTTY = 0x0020,
	sessionIsRemote = 0x1000,
	sessionWasInitialized = 0x8000
}

enum
{
	sessionKeepCurrentBootstrap = 0x8000
}

enum
{
	errSessionSuccess = 0,
	errSessionInvalidId = -60500,
	errSessionInvalidAttributes = -60501,
	errSessionAuthorizationDenied = -60502,
	errSessionValueNotSet = -60503,
	errSessionInternal = errAuthorizationInternal,
	errSessionInvalidFlags = errAuthorizationInvalidFlags
}

extern (C)
{
	int SessionGetInfo (uint session, SecuritySessionId* sessionId, SessionAttributeBits* attributes);
	int SessionCreate (uint flags, uint attributes);
}